/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * animation.h - constantes para manipulacao dos valores de profundidade de
 *               animacao.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    08.10.91  21:25 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _ANIMATION_DEFINED
#define _ANIMATION_DEFINED

#include "global.h"
#include "World.h"

EXPORT int REFERENCE_DEPTH;
EXPORT bool PAUSE;
EXPORT int STEP;
EXPORT int FRAME_DELAY;

inline bool animation_on() { return REFERENCE_DEPTH != 0; }

void frame_save(World *);
void frame_restore(World *);
void frame_stop_mark(World *);
void frame_delay_mark(World *);

// interface related functions
void animation_disable_interface(World *);
void animation_restore_interface(World *);

#endif ~_ANIMATION_DEFINED;





