/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * EO.h - Generic External Object Mode
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    12.01.93  15:52 	Cesar N. Gon 	  	Arquivo criado
 *
 */

#ifndef _EO_DEFINED
#define _EO_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"

class EO : public ExternalObjectMode {
  public:
    
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int animation_depth = 0, int reference_depth = 0) {
	cerr << "EO::binder called...\n";
	ResultObjects dummy;
	return dummy;
    }
    
    bool is_able_to_activate(const SelectedObjects &, const GraphicObjects &, World *) {
	cerr << "EO::is_able_to_active called...\n";
	return true;
    }

    void installer(World *) {
	cerr << "EO::install called...\n";
    }
    
    void uninstaller(World *) {
	cerr << "EO::uninstall called...\n";
    }

    
    void activator(World *) {
	cerr << "EO::activator called...\n";
    }
    
    void deactivator(World *) {
	cerr << "EO::deactivator called...\n";
    }

    bool click_select_down(World *, double x, double y) {
	cerr << "EO::click_select_down called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
    
    bool click_select_up(World *, double x, double y) {
	cerr << "EO::click_select_up called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
    
    bool click_adjust_down(World *, double x, double y) {
	cerr << "EO::click_adjust_down called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
    
    bool click_adjust_up(World *, double x, double y) {
	cerr << "EO::click_adjust_up called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
   	
    bool double_click(World *, double x, double y) {
	cerr << "EO::double_click called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
    
    bool loc_move(World *, double x, double y) {
	cerr << "EO::loc_move called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }
	
    bool loc_drag(World *, double x, double y) {
	cerr << "EO::loc_drag called...\n";
	cerr << "with x=" << x << " y=" << y << endl;
	return false;
    }

    bool ascii_key(World *, int key) {
	cerr << "EO:ascii_key...\n";
	cerr << "KEY: " << key << endl;
	return false;
    }
    
};

Algorithm* EO_link();

#endif ~_EO_DEFINED;




