/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti
                    Cesar N. Gon
                    Laerte F. Morgado

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/icon_load.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include "GraphicDemo_ui.h"

//
// Initialize an instance of object `popup_graphic_demo'.
//
void
GraphicDemo_popup_graphic_demo_objects::objects_initialize(Xv_opaque owner)
{
	popup_graphic_demo = popup_graphic_demo_create(owner);
	controls_graphic_demo = controls_graphic_demo_create(popup_graphic_demo);
	setting_graphic_demo_show = setting_graphic_demo_show_create(controls_graphic_demo);
	setting_graphic_demo_fade = setting_graphic_demo_fade_create(controls_graphic_demo);
	message_movie_frame = message_movie_frame_create(controls_graphic_demo);
	slider_movie_speed = slider_movie_speed_create(controls_graphic_demo);
	textfield_movie_frame_position = textfield_movie_frame_position_create(controls_graphic_demo);
	textfield_movie_number_of_frames = textfield_movie_number_of_frames_create(controls_graphic_demo);
	button_movie_show = button_movie_show_create(controls_graphic_demo);
	button_movie_fade = button_movie_fade_create(controls_graphic_demo);
}

//
// Create object `popup_graphic_demo' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::popup_graphic_demo_create(Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, this,
		XV_WIDTH, 244,
		XV_HEIGHT, 309,
		XV_LABEL, "Movie",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, FALSE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

//
// Create object `controls_graphic_demo' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::controls_graphic_demo_create(Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

//
// Create object `setting_graphic_demo_show' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::setting_graphic_demo_show_create(Xv_opaque owner)
{
	extern void		movie_show_mode_handler(Panel_item, int, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 20,
		XV_Y, 20,
		XV_WIDTH, 95,
		XV_HEIGHT, 106,
		PANEL_VALUE_X, 20,
		PANEL_VALUE_Y, 37,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LABEL_STRING, "  Show Mode",
		PANEL_NOTIFY_PROC, movie_show_mode_handler,
		PANEL_CHOICE_STRINGS,
			"Circular",
			"Direct",
			"Gray Scale",
			"Cross Strings",
			0,
		NULL);
	return obj;
}

//
// Create object `setting_graphic_demo_fade' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::setting_graphic_demo_fade_create(Xv_opaque owner)
{
	extern void		movie_fade_mode_handler(Panel_item, int, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 132,
		XV_Y, 20,
		XV_WIDTH, 84,
		XV_HEIGHT, 62,
		PANEL_VALUE_X, 132,
		PANEL_VALUE_Y, 37,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LABEL_STRING, " Fade Mode",
		PANEL_NOTIFY_PROC, movie_fade_mode_handler,
		PANEL_CHOICE_STRINGS,
			"Quick Fade",
			"Gray Scale",
			0,
		NULL);
	return obj;
}

//
// Create object `message_movie_frame' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::message_movie_frame_create(Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 20,
		XV_Y, 148,
		XV_WIDTH, 45,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Speed:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

//
// Create object `slider_movie_speed' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::slider_movie_speed_create(Xv_opaque owner)
{
	extern void		movie_speed_handler(Panel_item, int, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 20,
		XV_Y, 168,
		XV_WIDTH, 215,
		XV_HEIGHT, 20,
		PANEL_VALUE_X, 29,
		PANEL_VALUE_Y, 168,
		PANEL_SLIDER_WIDTH, 100,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, FALSE,
		PANEL_SHOW_RANGE, TRUE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 1,
		PANEL_MAX_VALUE, 10,
		PANEL_TICKS, 10,
		PANEL_NOTIFY_PROC, movie_speed_handler,
		NULL);
	return obj;
}

//
// Create object `textfield_movie_frame_position' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::textfield_movie_frame_position_create(Xv_opaque owner)
{
	extern Panel_setting	movie_frame_position_handler(Panel_item, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 20,
		XV_Y, 216,
		XV_WIDTH, 71,
		XV_HEIGHT, 32,
		PANEL_LABEL_STRING, "Frame:",
		PANEL_VALUE_X, 20,
		PANEL_VALUE_Y, 233,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, movie_frame_position_handler,
		NULL);
	return obj;
}

//
// Create object `textfield_movie_number_of_frames' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::textfield_movie_number_of_frames_create(Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 100,
		XV_Y, 233,
		XV_WIDTH, 94,
		XV_HEIGHT, 15,
		PANEL_LABEL_STRING, "of",
		PANEL_VALUE_X, 123,
		PANEL_VALUE_Y, 233,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 0,
		PANEL_READ_ONLY, TRUE,
		NULL);
	return obj;
}

//
// Create object `button_movie_show' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::button_movie_show_create(Xv_opaque owner)
{
	extern void		button_movie_show_handler(Panel_item, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 56,
		XV_Y, 276,
		XV_WIDTH, 51,
		XV_HEIGHT, 20,
		PANEL_LABEL_STRING, "Show",
		PANEL_NOTIFY_PROC, button_movie_show_handler,
		NULL);
	return obj;
}

//
// Create object `button_movie_fade' in the specified instance.

//
Xv_opaque
GraphicDemo_popup_graphic_demo_objects::button_movie_fade_create(Xv_opaque owner)
{
	extern void		button_movie_fade_handler(Panel_item, Event *);
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, this,
		XV_X, 132,
		XV_Y, 276,
		XV_WIDTH, 47,
		XV_HEIGHT, 20,
		PANEL_LABEL_STRING, "Fade",
		PANEL_NOTIFY_PROC, button_movie_fade_handler,
		NULL);
	return obj;
}








