/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * Integer.h
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _INTEGER_DEFINED
#define _INTEGER_DEFINED

#include <stdio.h>
#include <iostream.h>
#include "global.h"
#include "World.h"
#include "Obj.h"
#include "ExternalObj_id.h"	// obrigatorio em todo objeto externo

// forward declaration
class GraphicInteger;
 
class Integer : public Obj {
  public:
    // construtores
    Integer(char *s = "Integer", ObjType t = Generic_t, bool v = false) : Obj(s, t, v) { set(0); }
    Integer(long l) : Obj("Integer") { set(l); }
    Integer( Integer &i) : Obj(i.what_is(), i.stype, i.volati) { set(i.get()); }
         
    //destrutor
    ~Integer() {}

    // construtor virtual (simulado) que estabelece o relacionamento
    //
    //                   Integer --> GraphicInteger
    
    GraphicObj* new_GraphicObj();
    
    // funcao para auto-reproducao de um objeto - necessario para possibilitar 
    // que a interface manipule objetos externos ao geolab (alem disso torna
    // mais homogeneo o tratamento de objetos conhecidos e desconhecidos)

    Obj* reproduct()  {
    	return new Integer(*this);
    }
        
    // query & set functions
    void set(long l) { val = l; }
    long get()  { return val; }
    
    // inherited methods redefinition
    ObjType type()  { return Integer_t; }
    
    void print()  { cout << "Integer: " << val << endl; }

    void draw(World *w, GC gc = 0) ;

  protected:
    long val;
};

/*
 *
 * GraphicInteger
 *
 *
 */

class GraphicInteger : public GraphicObj {
  public:
    // construtores
    GraphicInteger() : GraphicObj(new Integer()) {}
    GraphicInteger(Integer *i) : GraphicObj(i) {}
    
    //destrutor
    ~GraphicInteger() {}
    
    // inherited methods redefinition
    void draw(World *, DrawMode);
};

typedef Integer* Integer_ptr;
typedef GraphicInteger* GraphicInteger_ptr;

#endif ~_INTEGER_DEFINED;




