/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * attributes.C - 
 *
 *             link flag -lm
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    22.05.92  21:11 	Cesar N. Gon  	         Arquivo criado
 *
 */


#include "color.h"
#include "line_settings.h"
#include "global.h"
#include "String.h"
#include "attributes.h"


// Esta variavel 'e utilizada no m'odulo 'geolab_stubs.C' na manipula,c~ao
// dos atributos via 'popup_objects_attributes'.
Attributes Obj_Attributes;

// Esta variavel 'e utilizada no m'odulo 'geolab_stubs.C' e conte'm sempre o
// valor default atual para os diversos atributos.
Attributes Default_Obj_Attributes;


Attributes::Attributes(Attributes& attr)
{
    *this = attr;
}


void Attributes::set_default()
{
    DELETABLE = 0; // Yes
    GLUE = 1;      // No
    HANDLES = 0;   // On
    LABEL = "";
    LINE_WIDTH = get_line_style_from_index(0);
    LINE_STYLE = get_line_style_from_index(SOLID);   
    FOREGROUND = get_pixel_from_value(BLACK);
    BACKGROUND = get_pixel_from_value(WHITE);
    INCREMENT = false;
    INCREMENT_VALUE = 1;
}

