/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * benchmark.C - definicao de algumas funcoes para auxiliar no trabalho de testes
 *               de algoritmos, como por exemplo medicao de performance (tempo).
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    31.10.91  13:45	Welson R. Jacometti	Arquivo Criado
 *
 */

#include <sys/time.h>
#include "benchmark.h"

#define MAX_SEC_VALUE	100000000	// three years for a SIGVTALRM (value in seconds)
#define MAX_USEC_VALUE	999999

typedef struct itimerval timevalues;

static timevalues initv, finalv, initr, finalr;

void start_timer() {
    initr.it_value.tv_sec = MAX_SEC_VALUE; 
    initr.it_value.tv_usec = MAX_USEC_VALUE;
    initv.it_value.tv_sec = MAX_SEC_VALUE; 
    initv.it_value.tv_usec = MAX_USEC_VALUE;
    setitimer(ITIMER_REAL, &initr, 0);
    setitimer(ITIMER_VIRTUAL, &initv, 0);
}

double get_real_ellapsed_time() {
    double sr, msr;
    getitimer(ITIMER_REAL, &finalr);
    sr = initr.it_value.tv_sec - finalr.it_value.tv_sec;
    msr = initr.it_value.tv_usec - finalr.it_value.tv_usec;
    return sr + (msr / 1e+6);
}

double get_virtual_ellapsed_time() {
    double sv, msv;
    getitimer(ITIMER_VIRTUAL, &finalv);
    sv = initv.it_value.tv_sec - finalv.it_value.tv_sec;
    msv = initv.it_value.tv_usec - finalv.it_value.tv_usec;
    return sv + (msv / 1e+6);
}




