/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * insert_simple.C - modulo de tratamento de eventos no modo de insercao de
 *                   objetos simples.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    12.12.91  08:45 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "insert_simple.h"
#include "color.h"
#include "line_settings.h"
#include "edit_mode.h"
#include "Obj.h"
#include "objects.h"

bool insert_simple_events(World *world, Xv_Window, Event *event) {
    static GraphicObj *current_object = 0;
    static Int_Mode mode = LeftButton;
    unsigned long fg, bg;
    int lw, ls;
    
    double X = world->virtual_xcoord(event_x(event));
    double Y = world->virtual_ycoord(event_y(event));
    
    switch (event_action(event)) {
      case ACTION_SELECT:
      case ACTION_ADJUST:
        if (event_is_down(event) && !current_object) {
          if (event_action(event) == ACTION_SELECT)
            mode = LeftButton;
          else
            mode = MiddleButton;
          current_object = new_object();
	  // Isto 'e necessario porque o construtor da classe GraphicObj n~ao
	  // ajusta as cores e atributos de linha no GC por falta do world.
	  // Gon (24/08/92).
	  current_object->get_color(fg, bg);
	  current_object->set_color(world, fg, bg);
	  current_object->get_line_attr(lw, ls);
	  current_object->set_line_attr(world, lw, ls);

          current_object->int_start(world, X, Y, mode);
          current_object->draw(world, XorMode);
        }
        else
          if (current_object) {
            current_object->draw(world, XorMode);
            current_object->int_end(world, X, Y, mode);
            current_object->draw(world, CopyMode);
            objects_insert(current_object);
            current_object = 0;
          }
        break;
        
      case LOC_DRAG:
        if (current_object) {
          current_object->draw(world, XorMode);
          current_object->int_change(world, X, Y, mode);
          current_object->draw(world, XorMode);
        }
        break;
    }
    
    return false;
}

