/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * zoom.h - header file de zoom.C
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    08.10.91  21:25 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _ZOOM_DEFINED
#define _ZOOM_DEFINED

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/svrimage.h>
#include <xview/cursor.h>
#include <assert.h>
#include "World.h"
#include "global.h"

EXPORT double GLASS1_FACTOR;
EXPORT double GLASS2_FACTOR;
EXPORT double ZOOM_FACTOR;
EXPORT bool ZOOM_CENTERED;
EXPORT bool ZOOM_STACKED;

void zoom_init(World *);
void zoom_reset(World *);
void zoom_in(World *);
void zoom_out(World *);
bool zoom_events(World *, Xv_Window, Event *);

#endif ~_ZOOM_DEFINED;





